ifndef cutscene_wdl;
define cutscene_wdl;

// ---------------------------------------------------------------------
// STARTHEADER
//
// ver: 4
// date: 050412
//
//
// title: Cut Scene (00)
// class: INTERFACE
// type: USER
// image: cutscene00.pcx
// help: Allows you to set up triggers to display cutscene (movies, audio, etc.).
// help: Note: Full multimedia support is only available in the commercial edition and above;
// help:the lower editions only support .wav and .mid files.
//
// note: All editions support .wav and .mid files. Only Commercial editions and above support .ogg, .mp3, avi, .mpg, .wmv, and .wma.
//
// gid01.wdl
// needs: trigger00.wdl
//
// external:
// prefix: cutscene00_
// idcode: 026
//
// ENDHEADER
// ---------------------------------------------------------------------



//----------------------------------------------------------------------
// section: Cutscene #1

// entry: Name of the cutscene media file
// id: 1
string cutscene00_file1_str = "file1.wav";
// entry: Trigger
// help: Trigger value used to play this file
// help: < 1 means the file will not be played
// id: 2
define	cutscene00_trigger1 = 0;
// entry: Volume
// id: 3
define	cutscene00_volume1 = 75;
// entry: Replay Time
// help: Time between re-play of the media file (-1, dont replay. 0-play always)
// cntl: spin -1 x 1
// id: 4
define	cutscene00_reset_time1 = -1;


var	cutscene00_handle1 = 0;

// Desc: Check for this cutscene's trigger
function	Cutscene00_Loop1()
{
	while(1)
	{
		wait(1);
		if(Trigger00_Check(cutscene00_trigger1,trigger00_bitlist) == 1)
		{
			// play media
			if(media_playing(cutscene00_handle1) == 0)	// not playing this media
			{
				cutscene00_handle1 = media_play(cutscene00_file1_str,null,cutscene00_volume1);

				if(cutscene00_reset_time1 < 0) { return; } // done with this cutscene
				if(cutscene00_reset_time1 > 0) { sleep(cutscene00_reset_time1); }
			}
		}
	}
}

//----------------------------------------------------------------------
// section: Cutscene #2

// entry: Name of the cutscene media file
// id: 10
string cutscene00_file2_str = "file1.wav";
// entry: Trigger
// help: Trigger value used to play this file
// help: < 1 means the file will not be played
// id: 11
define	cutscene00_trigger2 = 0;
// entry: Volume
// id: 12
define	cutscene00_volume2 = 75;
// entry: Replay Time
// help: Time between re-play of the media file (-1, dont replay. 0-play always)
// cntl: spin -1 x 1
// id: 13
define	cutscene00_reset_time2 = -1;
var	cutscene00_handle2 = 0;

// Desc: Check for this cutscene's trigger
function	Cutscene00_Loop2()
{
	while(1)
	{
		wait(1);
		if(Trigger00_Check(cutscene00_trigger2,trigger00_bitlist) == 1)
		{
			// play media
			if(media_playing(cutscene00_handle2) == 0)	// not playing this media
			{
				cutscene00_handle2 = media_play(cutscene00_file2_str,null,cutscene00_volume2);

				if(cutscene00_reset_time2 < 0) { return; } // done with this cutscene
				if(cutscene00_reset_time2 > 0) { sleep(cutscene00_reset_time2); }
			}
		}
	}
}

//----------------------------------------------------------------------
// section: Cutscene #3

// entry: Name of the cutscene media file
// id: 20
string cutscene00_file3_str = "file1.wav";
// entry: Trigger
// help: Trigger value used to play this file
// help: < 1 means the file will not be played
// id: 21
define	cutscene00_trigger3 = 0;
// entry: Volume
// id: 22
define	cutscene00_volume3 = 75;
// entry: Replay Time
// help: Time between re-play of the media file (-1, dont replay. 0-play always)
// cntl: spin -1 x 1
// id: 23
define	cutscene00_reset_time3 = -1;
var	cutscene00_handle3 = 0;

// Desc: Check for this cutscene's trigger
function	Cutscene00_Loop3()
{
	while(1)
	{
		wait(1);
		if(Trigger00_Check(cutscene00_trigger3,trigger00_bitlist) == 1)
		{
			// play media
			if(media_playing(cutscene00_handle3) == 0)	// not playing this media
			{
				cutscene00_handle3 = media_play(cutscene00_file3_str,null,cutscene00_volume3);

				if(cutscene00_reset_time3 < 0) { return; } // done with this cutscene
				if(cutscene00_reset_time3 > 0) { sleep(cutscene00_reset_time3); }
			}
		}
	}
}

//----------------------------------------------------------------------
// section: Cutscene #4

// entry: Name of the cutscene media file
// id: 30
string cutscene00_file4_str = "file1.wav";
// entry: Trigger
// help: Trigger value used to play this file
// help: < 1 means the file will not be played
// id: 31
define	cutscene00_trigger4 = 0;
// entry: Volume
// id: 32
define	cutscene00_volume4 = 75;
// entry: Replay Time
// help: Time between re-play of the media file (-1, dont replay. 0-play always)
// cntl: spin -1 x 1
// id: 33
define	cutscene00_reset_time4 = -1;
var	cutscene00_handle4 = 0;

// Desc: Check for this cutscene's trigger
function	Cutscene00_Loop4()
{
	while(1)
	{
		wait(1);
		if(Trigger00_Check(cutscene00_trigger4,trigger00_bitlist) == 1)
		{
			// play media
			if(media_playing(cutscene00_handle4) == 0)	// not playing this media
			{
				cutscene00_handle4 = media_play(cutscene00_file4_str,null,cutscene00_volume4);

				if(cutscene00_reset_time4 < 0) { return; } // done with this cutscene
				if(cutscene00_reset_time4 > 0) { sleep(cutscene00_reset_time4); }
			}
		}
	}
}


//----------------------------------------------------------------------
// section: Cutscene #5

// entry: Name of the cutscene media file
// id: 40
string cutscene00_file5_str = "file1.wav";
// entry: Trigger
// help: Trigger value used to play this file
// help: < 1 means the file will not be played
// id: 41
define	cutscene00_trigger5 = 0;
// entry: Volume
// id: 42
define	cutscene00_volume5 = 75;
// entry: Replay Time
// help: Time between re-play of the media file (-1, dont replay. 0-play always)
// cntl: spin -1 x 1
// id: 43
define	cutscene00_reset_time5 = -1;
var	cutscene00_handle5 = 0;

// Desc: Check for this cutscene's trigger
function	Cutscene00_Loop5()
{
	while(1)
	{
		wait(1);
		if(Trigger00_Check(cutscene00_trigger5,trigger00_bitlist) == 1)
		{
			// play media
			if(media_playing(cutscene00_handle5) == 0)	// not playing this media
			{
				cutscene00_handle5 = media_play(cutscene00_file5_str,null,cutscene00_volume5);

				if(cutscene00_reset_time5 < 0) { return; } // done with this cutscene
				if(cutscene00_reset_time5 > 0) { sleep(cutscene00_reset_time5); }
			}
		}
	}
}






starter  Cutscene00_Init()
{
	// only check if the triggers are valid
	if(cutscene00_trigger1 > 0) { Cutscene00_Loop1(); }
	if(cutscene00_trigger2 > 0) { Cutscene00_Loop2(); }
	if(cutscene00_trigger3 > 0) { Cutscene00_Loop3(); }
	if(cutscene00_trigger4 > 0) { Cutscene00_Loop4(); }
	if(cutscene00_trigger5 > 0) { Cutscene00_Loop5(); }

}




endif;	//  cutscene00_wdl