ifndef levels_wdl;
define levels_wdl;

// ---------------------------------------------------------------------
// STARTHEADER
//
// ver: 4
// date: 050412
//
// title: Levels (00)
// class: MISC
// type: USER
// image: levels00.pcx
// help: Allows multiple (up to 9) levels to be linked together. The player can passed between levels.
//
// needs: gid01.wdl, plSelect.wdl
//
// external:
//
// prefix: levels00_
// idcode: 023
//
// ENDHEADER
// ---------------------------------------------------------------------


// temp vectors
var	levels00_pos_vec[3];
var	levels00_ang_vec[3];

// current state of each levels
var	levels00_states[9];
// 0 - unvisited
// >1 - visited, saved with this id (levelname#.sav)

// current level
var	levels00_current = 1;


// array used to store player skills
var	levels00_plSkills[100];

define	levels00_max_entry_pts = 6;

// use var_info to keep information between levels
var_info		levels00_entry_handle[levels00_max_entry_pts];


// string to hold temp values
string	levels00_temp[256];

// Base level resources are already loaded
string	levels00_1_str;		// string is set in starter


// entry: The second level's folder.
// id: 10
path  ".";

// entry: The second level of a multi-level project.
// entry_help: If "none.wmb" is used, no level is loaded
// id: 2
string levels00_2_str = <none.wmb>;
level	levels00_2_str;      // make sure we load those resources
bind	levels00_2_str;		// load the level itself

// entry: The third level's folder.
// id: 11
path  ".";
// entry: The third level of a multi-level project.
// entry_help: If "none.wmb" is used, no level is loaded
// id: 3
string levels00_3_str = <none.wmb>;
level	levels00_3_str;      // make sure we load those resources
bind	levels00_3_str;		// load the level itself

// entry: The fourth level's folder.
// id: 12
path  ".";
// entry: The fourth level of a multi-level project.
// entry_help: If "none.wmb" is used, no level is loaded
// id: 4
string levels00_4_str = <none.wmb>;
level	levels00_4_str;      // make sure we load those resources
bind	levels00_4_str;		// load the level itself

// entry: The fifth level's folder.
// id: 13
path  ".";
// entry: The fifth level of a multi-level project.
// entry_help: If "none.wmb" is used, no level is loaded
// id: 5
string levels00_5_str = <none.wmb>;
level	levels00_5_str;      // make sure we load those resources
bind	levels00_5_str;		// load the level itself

// entry: The sixth level's folder.
// id: 14
path  ".";
// entry: The sixth level of a multi-level project.
// entry_help: If "none.wmb" is used, no level is loaded
// id: 6
string levels00_6_str = <none.wmb>;
level	levels00_6_str;      // make sure we load those resources
bind	levels00_6_str;		// load the level itself

// entry: The seventh level's folder.
// id: 15
path  ".";
// entry: The seventh level of a multi-level project.
// entry_help: If "none.wmb" is used, no level is loaded
// id: 7
string levels00_7_str = <none.wmb>;
level	levels00_7_str;      // make sure we load those resources
bind	levels00_7_str;		// load the level itself

// entry: The eighth level's folder.
// id: 16
path  ".";
// entry: The eighth level of a multi-level project.
// entry_help: If "none.wmb" is used, no level is loaded
// id: 8
string levels00_8_str = <none.wmb>;
level	levels00_8_str;      // make sure we load those resources
bind	levels00_8_str;		// load the level itself

// entry: The ninth level's folder.
// id: 17
path  ".";
// entry: The ninth level of a multi-level project.
// entry_help: If "none.wmb" is used, no level is loaded
// id: 9
string levels00_9_str = <none.wmb>;
level	levels00_9_str;      // make sure we load those resources
bind	levels00_9_str;		// load the level itself




// ---------------------------------------------------------------------
// Functions


// Desc: temp store the entity skills
function Levels00_Store_Skills(ent)
{
	my = ent;

	// store all 48 skills
	vec_set(levels00_plSkills[0],my.skill1);  	// 1-3
	vec_set(levels00_plSkills[3],my.skill4);  	// 4-6
	vec_set(levels00_plSkills[6],my.skill7);  	// 7-9
	vec_set(levels00_plSkills[9],my.skill10); 	// 10-12

	vec_set(levels00_plSkills[12],my.skill13); 	// 13-15
	vec_set(levels00_plSkills[15],my.skill16); 	// 16-18
	vec_set(levels00_plSkills[18],my.skill19); 	// 19-21
	vec_set(levels00_plSkills[21],my.skill22); 	// 22-24

	vec_set(levels00_plSkills[24],my.skill25); 	// 25-27
 	vec_set(levels00_plSkills[27],my.skill28); 	// 28-30
	vec_set(levels00_plSkills[30],my.skill31); 	// 31-33
	vec_set(levels00_plSkills[33],my.skill34); 	// 34-36

	vec_set(levels00_plSkills[36],my.skill37); 	// 37-39
	vec_set(levels00_plSkills[39],my.skill40); 	// 40-42
	vec_set(levels00_plSkills[42],my.skill43); 	// 43-45
	vec_set(levels00_plSkills[45],my.skill46); 	// 46-48

	vec_set(levels00_plSkills[48],my.skill49); 	// 49-51
	vec_set(levels00_plSkills[51],my.skill52); 	// 52-54
	vec_set(levels00_plSkills[54],my.skill55); 	// 55-57
	vec_set(levels00_plSkills[57],my.skill58); 	// 58-60

	vec_set(levels00_plSkills[60],my.skill61); 	// 61-63
	vec_set(levels00_plSkills[63],my.skill64); 	// 64-66
	vec_set(levels00_plSkills[66],my.skill67); 	// 67-69
	vec_set(levels00_plSkills[69],my.skill70); 	// 70-72

	vec_set(levels00_plSkills[72],my.skill73); 	// 73-
	vec_set(levels00_plSkills[75],my.skill76); 	// 76
	vec_set(levels00_plSkills[78],my.skill79); 	// 79
	vec_set(levels00_plSkills[81],my.skill82); 	// 82

	vec_set(levels00_plSkills[84],my.skill85); 	//
	vec_set(levels00_plSkills[87],my.skill88); 	//
	vec_set(levels00_plSkills[90],my.skill91); 	//
	vec_set(levels00_plSkills[93],my.skill94); 	//

	vec_set(levels00_plSkills[96],my.skill97); 	// 97-99
	levels00_plSkills[99] = my.skill100;
}

// Desc: restore entity skills from temp storage
function	Levels00_Restore_Skills(ent)
{
	my = ent;

	// store all 48 skills
	vec_set(my.skill1,levels00_plSkills[0]);  	// 1-3
	vec_set(my.skill4,levels00_plSkills[3]);  	// 4-6
	vec_set(my.skill7,levels00_plSkills[6]);  	// 7-9
	vec_set(my.skill10,levels00_plSkills[9]); 	// 10-12

	vec_set(my.skill13,levels00_plSkills[12]); 	// 13-15
	vec_set(my.skill16,levels00_plSkills[15]); 	// 16-18
	vec_set(my.skill19,levels00_plSkills[18]); 	// 19-21
	vec_set(my.skill22,levels00_plSkills[21]); 	// 22-24

	vec_set(my.skill25,levels00_plSkills[24]); 	// 25-27

	vec_set(my.skill28,levels00_plSkills[27]); 	// 28-30
	vec_set(my.skill31,levels00_plSkills[30]); 	// 31-33
	vec_set(my.skill34,levels00_plSkills[33]); 	// 34-36
	vec_set(my.skill37,levels00_plSkills[36]); 	// 37-39
	vec_set(my.skill40,levels00_plSkills[39]); 	// 40-42
	vec_set(my.skill43,levels00_plSkills[42]); 	// 43-45
	vec_set(my.skill46,levels00_plSkills[45]); 	// 46-48

	vec_set(my.skill49,levels00_plSkills[48]); 	// 49-51
	vec_set(my.skill52,levels00_plSkills[51]); 	// 52-54
	vec_set(my.skill55,levels00_plSkills[54]); 	// 55-57
	vec_set(my.skill58,levels00_plSkills[57]); 	// 58-60

	vec_set(my.skill61,levels00_plSkills[60]); 	// 61-63
	vec_set(my.skill64,levels00_plSkills[63]); 	// 64-66
	vec_set(my.skill67,levels00_plSkills[66]); 	// 67-69
	vec_set(my.skill70,levels00_plSkills[69]); 	// 70-72

	vec_set(my.skill73,levels00_plSkills[72]); 	// 73-
	vec_set(my.skill76,levels00_plSkills[75]); 	// 76
	vec_set(my.skill79,levels00_plSkills[78]); 	// 79
	vec_set(my.skill82,levels00_plSkills[81]); 	// 82

	vec_set(my.skill85,levels00_plSkills[84]); 	//
	vec_set(my.skill88,levels00_plSkills[87]); 	//
	vec_set(my.skill91,levels00_plSkills[90]); 	//
	vec_set(my.skill94,levels00_plSkills[93]); 	//

	vec_set(my.skill97,levels00_plSkills[96]); 	// 97-99
	my.skill100 = levels00_plSkills[99];
}



// Desc: Save state of current level
function Levels00_Save_State(level_num)
{
	if((level_num <1)||(level_num>9)) { return(-1); }
	if(level_num < 2) // 1
	{
		// save level 1
diag("\n=====\nSave Level 1\n");
diag(levels00_1_str);
		levels00_states[0] += 1;
		game_save(levels00_1_str,levels00_states[0],SV_LEVEL+SV_POINTERS+SV_FUNCTIONS+SV_INFO);
		return;
	}
	if(level_num < 3) // 2
	{
diag("\n=====\nSave Level 2\n");
diag(levels00_2_str);
		// save level 2
		levels00_states[1] += 1;
		game_save(levels00_2_str,levels00_states[1],SV_LEVEL+SV_POINTERS+SV_FUNCTIONS+SV_INFO);
		return;
	}
	if(level_num < 4) // 3
	{
diag("\n=====\nSave Level 3\n");
diag(levels00_3_str);
		// save level 3
		levels00_states[2] += 1;
		game_save(levels00_3_str,levels00_states[2],SV_LEVEL+SV_POINTERS+SV_FUNCTIONS+SV_INFO);
		return;
	}
	if(level_num < 5) // 4
	{
diag("\n=====\nSave Level 4\n");
diag(levels00_2_str);
		// save level 4
		levels00_states[3] += 1;
		game_save(levels00_4_str,levels00_states[3],SV_LEVEL+SV_POINTERS+SV_FUNCTIONS+SV_INFO);
		return;
	}
	if(level_num < 6) // 5
	{
diag("\n=====\nSave Level 2\n");
diag(levels00_5_str);
		// save level 5
		levels00_states[4] += 1;
		game_save(levels00_5_str,levels00_states[4],SV_LEVEL+SV_POINTERS+SV_FUNCTIONS+SV_INFO);
		return;
	}
	if(level_num < 7) // 6
	{
diag("\n=====\nSave Level 6\n");
diag(levels00_6_str);
		// save level 6
		levels00_states[5] += 1;
		game_save(levels00_6_str,levels00_states[5],SV_LEVEL+SV_POINTERS+SV_FUNCTIONS+SV_INFO);
		return;
	}
	if(level_num < 8) // 7
	{
diag("\n=====\nSave Level 7\n");
diag(levels00_7_str);
		// save level 7
		levels00_states[6] += 1;
		game_save(levels00_7_str,levels00_states[6],SV_LEVEL+SV_POINTERS+SV_FUNCTIONS+SV_INFO);
		return;
	}
	if(level_num < 9) // 8
	{
diag("\n=====\nSave Level 8\n");
diag(levels00_8_str);
		// save level 2
		levels00_states[7] += 1;
		game_save(levels00_8_str,levels00_states[7],SV_LEVEL+SV_POINTERS+SV_FUNCTIONS+SV_INFO);
		return;
	}

diag("\n=====\nSave Level 9\n");
diag(levels00_9_str);
	// save level 2
	levels00_states[8] += 1;
	game_save(levels00_9_str,levels00_states[8],SV_LEVEL+SV_POINTERS+SV_FUNCTIONS+SV_INFO);
}


// Desc: Load the level corresponding to the number
function Levels00_Load(level_num)
{
	if((level_num <1)||(level_num>9)) { return(-1); }
	if(level_num < 2) // 1
	{
		// Load level 1
diag("\n=====\nLoad Level 1\n");
diag(levels00_1_str);

		// restore if already visited
		if(levels00_states[0] > 0)
		{
			if(game_load(levels00_1_str,levels00_states[0]) <= 0)
			{
				diag("\n**ERROR** Level 1 did not load!");
				return(-1);
			}
		}
		else
		{
			// load level for the first time
			// add ".wmb" to load level
			str_cpy(levels00_temp,levels00_1_str);
			str_cat(levels00_temp,".wmb");
			level_load(levels00_temp);
		}
		levels00_current = 1;
		return(levels00_current);
	}
	if(level_num < 3) // 2
	{
		// Load level 2
diag("\n=====\nLoad Level 2\n");
diag(levels00_2_str);
 		// restore if already visited
		if(levels00_states[1] > 0)
		{
			if(game_load(levels00_2_str,levels00_states[1]) <= 0)
			{
				diag("\n**ERROR** Level 2 did not load!");
				return(-2);
			}
		}
		else
		{
			// load level for the first time
			str_cpy(levels00_temp,levels00_2_str);
			str_cat(levels00_temp,".wmb");
			level_load(levels00_temp);
		}
		levels00_current = 2;
		return(levels00_current);
	}
	if(level_num < 4) // 3
	{
		// Load level 3
diag("\n=====\nLoad Level 3\n");
diag(levels00_3_str);

 		// restore if already visited
		if(levels00_states[2] > 0)
		{
			if(game_load(levels00_3_str,levels00_states[2]) <= 0)
			{
				diag("\n**ERROR** Level 3 did not load!");
				return(-3);
			}
		}
		else
		{
			// load level for the first time
			str_cpy(levels00_temp,levels00_3_str);
			str_cat(levels00_temp,".wmb");
			level_load(levels00_temp);
		}
		levels00_current = 3;
		return(levels00_current);
	}
	if(level_num < 5) // 4
	{
		// Load level 4
diag("\n=====\nLoad Level 4\n");
diag(levels00_4_str);

 		// restore if already visited
		if(levels00_states[3] > 0)
		{
			if(game_load(levels00_4_str,levels00_states[3]) <= 0)
			{
				diag("\n**ERROR** Level 4 did not load!");
				return(-4);
			}
		}
		else
		{
			// load level for the first time
			str_cpy(levels00_temp,levels00_4_str);
			str_cat(levels00_temp,".wmb");
			level_load(levels00_temp);
		}
		levels00_current = 4;
		return(levels00_current);
	}
	if(level_num < 6) // 5
	{
		// Load level 5
diag("\n=====\nLoad Level 5\n");
diag(levels00_5_str);

 		// restore if already visited
		if(levels00_states[4] > 0)
		{
			if(game_load(levels00_5_str,levels00_states[4]) <= 0)
			{
				diag("\n**ERROR** Level 5 did not load!");
				return(-5);
			}
		}
		else
		{
			// load level for the first time
			str_cpy(levels00_temp,levels00_5_str);
			str_cat(levels00_temp,".wmb");
			level_load(levels00_temp);
		}
		levels00_current = 5;
		return(levels00_current);
	}
	if(level_num < 7) // 6
	{
		// Load level 6
diag("\n=====\nLoad Level 6\n");
diag(levels00_6_str);

 		// restore if already visited
		if(levels00_states[5] > 0)
		{
			if(game_load(levels00_6_str,levels00_states[5]) <= 0)
			{
				diag("\n**ERROR** Level 6 did not load!");
				return(-6);
			}
		}
		else
		{
			// load level for the first time
			str_cpy(levels00_temp,levels00_6_str);
			str_cat(levels00_temp,".wmb");
			level_load(levels00_temp);
		}
		levels00_current = 6;
		return(levels00_current);
	}
	if(level_num < 8) // 7
	{
		// Load level 7
diag("\n=====\nLoad Level 7\n");
diag(levels00_7_str);

 		// restore if already visited
		if(levels00_states[6] > 0)
		{
			if(game_load(levels00_7_str,levels00_states[6]) <= 0)
			{
				diag("\n**ERROR** Level 7 did not load!");
				return(-7);
			}
		}
		else
		{
			// load level for the first time
			str_cpy(levels00_temp,levels00_7_str);
			str_cat(levels00_temp,".wmb");
			level_load(levels00_temp);
		}
		levels00_current = 7;
		return(levels00_current);
	}
	if(level_num < 9) // 8
	{
		// Load level 8
diag("\n=====\nLoad Level 8\n");
diag(levels00_8_str);

 		// restore if already visited
		if(levels00_states[7] > 0)
		{
			if(game_load(levels00_8_str,levels00_states[7]) <= 0)
			{
				diag("\n**ERROR** Level 8 did not load!");
				return(-8);
			}
		}
		else
		{
			// load level for the first time
			str_cpy(levels00_temp,levels00_8_str);
			str_cat(levels00_temp,".wmb");
			level_load(levels00_temp);
		}
		levels00_current = 8;
		return(levels00_current);
	}
	// Load level 9
diag("\n=====\nLoad Level 9\n");
diag(levels00_9_str);

 	// restore if already visited
	if(levels00_states[8] > 0)
	{
		if(game_load(levels00_9_str,levels00_states[8]) <= 0)
		{
			diag("\n**ERROR** Level 9 did not load!");
			return(-9);
		}
	}
	else
	{
			// load level for the first time
			str_cpy(levels00_temp,levels00_9_str);
			str_cat(levels00_temp,".wmb");
			level_load(levels00_temp);
	}
	levels00_current = 9;
	return(levels00_current);
}


// Desc: Send the player to a new level at the entry point
// You = player entity
function	Levels00_Send_Entity(level_num,entry_point)
{
	if((level_num <1)||(level_num>9)) { return(-1); }
	my = null;    // need to make this a global function

	// level is changing
	gid01_level_state = gid01_level_change;

	// freeze entities
	freeze_mode = 1;

	// save state of the current level
	Levels00_Save_State(levels00_current);

	// copy player values
	if(plSelect_curr_ent != NULL)
	{
		// store values in a temporary array
		Levels00_Store_Skills(plSelect_curr_ent);
	}

	wait(1);

	// load level
	if(Levels00_Load(level_num) <= 0)
	{
		// new level did not load
		diag("\n**ERROR** Levels00_Send_Entity: Level did not load!");
		gid01_level_state = gid01_level_loaded;
		return;
	}
	wait(2);

	// unfreeze everything
	freeze_mode = 0;
	wait(1);	// allow entities to init

	// move the player to the level starting position choosen (entry_point)
	if(plSelect_curr_ent != NULL)
	{
		entry_point -= 1;
		if(levels00_entry_handle[entry_point] != 0)
		{
			me = ptr_for_handle(levels00_entry_handle[entry_point]);

			// move player to entry point
			vec_set(plSelect_curr_ent.pan,levels00_ang_vec);
 		  	vec_add(plSelect_curr_ent.pan,my.pan);

			vec_set(plSelect_curr_ent.x,levels00_pos_vec.x);
 		 	vec_add(plSelect_curr_ent.x,my.x);


		}
		else
		{
			// no entry point, start at origin
			vec_set(plSelect_curr_ent.x,nullskill);
			vec_set(plSelect_curr_ent.pan,nullskill);
		}

		// restore player's skills
		Levels00_Restore_Skills(plSelect_curr_ent);

	}

	// level is done loading
	gid01_level_state = gid01_level_loaded;
}


/*
function LEVELS00_ONE()
{
	// get distance to player
	vec_set(levels00_pos_vec,nullvector);
	// get orientation of player
	vec_set(levels00_ang_vec,nullvector);
 	Levels00_Send_Entity(1,1);
}

function LEVELS00_TWO()
{
	// get distance to player
	vec_set(levels00_pos_vec,nullvector);
	// get orientation of player
	vec_set(levels00_ang_vec,nullvector);
 	Levels00_Send_Entity(2,1);
}
ON_T LEVELS00_ONE;
ON_Y LEVELS00_TWO;
*/

// ---------------------------------------------------------------------
// Starter

starter	Levels00_Init()
{
	// set the level 1 string to the first level
	str_cpy(levels00_1_str,level_str);

	// remove ".wmb" from all strings
	str_trunc(levels00_1_str,4);
	str_trunc(levels00_2_str,4);
	str_trunc(levels00_3_str,4);
	str_trunc(levels00_4_str,4);
	str_trunc(levels00_5_str,4);
	str_trunc(levels00_6_str,4);
	str_trunc(levels00_7_str,4);
	str_trunc(levels00_8_str,4);
	str_trunc(levels00_9_str,4);
}



// ---------------------------------------------------------------------
// Actions



define	_id__023,SKILL1;	// Entry/Exit point id (1-6)
define	_Target__023,SKILL2;	// Target Level (1-9)

// action: Levels00_Entry_Pt
// title: Entry Point
// Desc: Entry point of a level (player will start here)
// uses: _id__023
//------------------
// help: Links to the Exit Point of the same ID.
// cntl: spin 1 6 1
//	skill1: ID 1
action Levels00_Entry_Pt
{
	my.passable = on; my.invisible = on;

	if(my._id__023 <= 1)
	{
		my._id__023 = 0;
	}
	else
	{
		if(my._id__023 > levels00_max_entry_pts)
		{
			my._id__023 = levels00_max_entry_pts-1;
		}
		else  // in range
		{
			my._id__023 = int(my._id__023) - 1;
		}
	}

	// set the local array to this entity
	// NOTE: this works because the entities are loaded on level load and pointers are saved between switches
	levels00_entry_handle[my._id__023] = handle(my);
}

function Levels00_Exit_Pt_Event()
{
	// make sure this is the player
	if(YOU != plSelect_curr_ent) { return; }
	// don't activate is already changing levels
	if(gid01_level_state == gid01_level_change) { return; }

	// get distance to player
	vec_diff(levels00_pos_vec,your.x,my.x);
	// get orientation of player
	vec_set(levels00_ang_vec,your.pan);

	Levels00_Send_Entity(my._Target__023,my._id__023);
}


// action: Levels00_Exit_Pt
// title: Exit Point
// Desc: Exit point of a level.
// uses: _id__023, _Target__023
//------------------
// help: Links to the Entry Point of the same ID.
// cntl: spin 1 6 1
//	skill1: ID 1
//
// help: Target level we are going to.
// cntl: spin 1 9 1
// skill2: TargetLevel 2
action Levels00_Exit_Pt
{
	my.passable = off; my.invisible = off;
	my.transparent = on; my.alpha = 1;

	my.event = Levels00_Exit_Pt_Event;
	my.enable_impact = on;


	// when the player gets within trigger range...
}


endif; // levels00_wdl