ifndef plBipedHUD_wdl;
define plBipedHUD_wdl;

// ---------------------------------------------------------------------
// STARTHEADER
//
// ver: 4
// date: 050412
//
//
// title: Biped Player Heads-Up Display (01)
// class: PLAYER
// type: USER
// image: plBipedHUD01.pcx
// help: Display a "Heads Up Display" representing things like the player's
// help:current health & armor.
//
//
// needs: gid01.wdl
// needs: plSelect.wdl, cameraTarget.wdl
// needs: miscInput01.wdl, plBipedInput01.wdl
// needs: bipedPhy01.wdl,
// needs: bipedAnim01.wdl, bipedSnd01.wdl
// needs: plBiped01.wdl
//
// prefix: plBipedHUD01_
// idcode: 013
//
// uses: entity*	plBiped01_entity; // pointer to the biped entity (plBiped01.wdl)
//
// ENDHEADER
// ---------------------------------------------------------------------





// ---------------------------------------------------------------------
// section: Health Panel

// entry: Health Pos
// entry_help: -1-off, 0-free, 1-upper left, 2-upper right, 3-lower left, 4-lower right
// cntl: spin -1 4 1
// id: 9
define	plBipedHUD01_health_pos = 3;

// entry: Panel Font
// id: 1
font	plBipedHUD01_health_font = <font1_red.pcx>,12,16;
// entry: Panel Bitmap
// id: 2
bmap plBipedHUD01_health_bmp = <heart.pcx>;


// entry: X offset
// entry_help: Distance horz from edge
// id: 3
define	plBipedHUD01_hposx = 0;
// entry: Y offset
// entry_help: Distance vert from edge
// id: 4
define	plBipedHUD01_hposy = 2;


// entry: Digit X Offset
// id:11
define	plBipedHUD01_hdigx = 6;
// entry: Digit Y Offset
// id:11
define	plBipedHUD01_hdigy = -2;

panel plBipedHUD01_Health_Pan
{
	bmap = plBipedHUD01_health_bmp;
	pos_X = plBipedHUD01_hposx;
	pos_y = plBipedHUD01_hposy;
	digits = plBipedHUD01_hdigx,plBipedHUD01_hdigy,4,plBipedHUD01_health_font,1,plBiped01_entity._health__003;
	flags = overlay,refresh,visible;
}

// ---------------------------------------------------------------------
// section: Armor Panel

// entry: Armor Pos
// help: -1-off, 0-free, 1-upper left, 2-upper right, 3-lower left, 4-lower right
// cntl: spin -1 4 1
// id: 10
define	plBipedHUD01_armor_pos = -1;

// entry: Armor Panel Font
// id: 5
font	plBipedHUD01_armor_font = <font1_blue.pcx>,12,16;
// entry: Armor Panel Bitmap
// id: 6
bmap plBipedHUD01_armor_bmp = <armor.pcx>;


// entry: X position
// help: Distance horz from edge
// id: 7
define plBipedHUD01_aposx = 0;
// entry: Y position
// help: Distance vert from edge
// id: 8
define plBipedHUD01_aposy = 20;

// entry: Digit X Offset
// id:12
define	plBipedHUD01_adigx = 6;
// entry: Digit Y Offset
// id:13
define	plBipedHUD01_adigy = -2;


panel plBipedHUD01_Armor_Pan
{
	bmap = plBipedHUD01_armor_bmp;
	pos_x = plBipedHUD01_aposx;
	pos_y = plBipedHUD01_aposy;
	digits = plBipedHUD01_adigx,plBipedHUD01_adigy,4,plBipedHUD01_armor_font,1,plBiped01_entity._armor__003;
	flags = overlay,refresh,visible;
}

// used to store the old resolution
var	plBipedHUD01_old_health_mode = 0;
starter	PlBipedHUD01_Health()
{
	// remove panel
	if(plBipedHUD01_health_pos<0)
	{
		plBipedHUD01_Health_Pan.visible = off;
		plBipedHUD01_Health_Pan.refresh = off;
		return;
	}

	// panel uses set position
	if((plBipedHUD01_health_pos == 0) || (plBipedHUD01_health_pos > 4))
	{
		return;
	}

	while(1)
	{
		if(plBipedHUD01_old_health_mode !=  video_mode)
		{

			if(plBipedHUD01_health_pos < 2)
			{
				// 1-upper left
				plBipedHUD01_Health_Pan.pos_x = plBipedHUD01_hposx;
				plBipedHUD01_Health_Pan.pos_y = plBipedHUD01_hposy;
			}
			else
			{
				if(plBipedHUD01_health_pos < 3)
				{
					// 2-upper right,
					plBipedHUD01_Health_Pan.pos_x = (screen_size.x - bmap_width(plBipedHUD01_health_bmp)) - plBipedHUD01_hposx;
					plBipedHUD01_Health_Pan.pos_y = plBipedHUD01_hposy;

				}
				else
				{
					if(plBipedHUD01_health_pos < 4)
					{
						// 3-lower left
						plBipedHUD01_Health_Pan.pos_x = plBipedHUD01_hposx;
						plBipedHUD01_Health_Pan.pos_y = (screen_size.y - bmap_height(plBipedHUD01_health_bmp)) - plBipedHUD01_hposy;

					}
					else
					{
						// 4-lower right
	 					plBipedHUD01_Health_Pan.pos_x = (screen_size.x - bmap_width(plBipedHUD01_health_bmp)) - plBipedHUD01_hposx;
						plBipedHUD01_Health_Pan.pos_y = (screen_size.y - bmap_height(plBipedHUD01_health_bmp)) - plBipedHUD01_hposy;
					}

				}
			}
			plBipedHUD01_old_health_mode = video_mode;
		}
		wait(5); 	// no need to update every frame
	}
}

// used to store the old resolution
var	plBipedHUD01_old_armor_mode = 0;
starter	PlBipedHUD01_Armor()
{
	// remove panel
	if(plBipedHUD01_armor_pos<0)
	{
		plBipedHUD01_Armor_Pan.visible = off;
		plBipedHUD01_Armor_Pan.refresh = off;
		return;
	}

	// panel uses set position
	if((plBipedHUD01_armor_pos == 0) || (plBipedHUD01_armor_pos > 4))
	{
		return;
	}

	while(1)
	{
		if(plBipedHUD01_old_armor_mode !=  video_mode)
		{

			if(plBipedHUD01_armor_pos < 2)
			{
				// 1-upper left
				plBipedHUD01_Armor_Pan.pos_x = 0;
				plBipedHUD01_Armor_Pan.pos_y = 2;   // bug(?) requires a 2 pixel offset to show digits
			}
			else
			{
				if(plBipedHUD01_armor_pos < 3)
				{
					// 2-upper right,
					plBipedHUD01_Armor_Pan.pos_x = (screen_size.x - bmap_width(plBipedHUD01_armor_bmp));
					plBipedHUD01_Armor_Pan.pos_y = 2;  // bug(?) requires a 2 pixel offset to show digits

				}
				else
				{
					if(plBipedHUD01_armor_pos < 4)
					{
						// 3-lower left
						plBipedHUD01_Armor_Pan.pos_x = 0;
						plBipedHUD01_Armor_Pan.pos_y = (screen_size.y - bmap_height(plBipedHUD01_armor_bmp));;

					}
					else
					{
						// 4-lower right
	 					plBipedHUD01_Armor_Pan.pos_x = (screen_size.x - bmap_width(plBipedHUD01_armor_bmp));
						plBipedHUD01_Armor_Pan.pos_y = (screen_size.y - bmap_height(plBipedHUD01_armor_bmp));;
					}

				}
			}
			plBipedHUD01_old_armor_mode = video_mode;
		}
		wait(5); 	// no need to update every frame
	}
}


endif;